//+------------------------------------------------------------------+
//|                                               Chande trend index |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   DeepSkyBlue
#property indicator_width1   2
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int  LookBackPeriod   = 21;
extern int  Price            = PRICE_CLOSE;
extern bool UseAbsoluteValue = true;

//
//
//
//
//

double cti[];
double ctt[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(2);
      SetIndexBuffer(0,cti);
      SetIndexBuffer(1,ctt);
      
      //
      //
      //
      //
      //
      
      if (UseAbsoluteValue)
      {
         SetLevelValue(0,1);
         SetLevelValue(1,EMPTY_VALUE);
      }
      else
      {
         SetLevelValue(0, 1);
         SetLevelValue(1,-1);
      }
   
    return(0); }
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-LookBackPeriod-1);

   //
   //
   //
   //
   //
   
   for (i=limit; i>= 0; i--) ctt[i] = MathLog(iMA(NULL,0,1,0,MODE_SMA,Price,i)/iMA(NULL,0,1,0,MODE_SMA,Price,i+1));
   for (i=limit; i>= 0; i--)
   {
      double stddev = iStdDevOnArray(ctt,0,LookBackPeriod,0,MODE_SMA,i);
      double temp   = MathLog(iMA(NULL,0,1,0,MODE_SMA,Price,i)/iMA(NULL,0,1,0,MODE_SMA,Price,i+LookBackPeriod))/(stddev*MathSqrt(LookBackPeriod));
      if (UseAbsoluteValue)
            cti[i] = MathAbs(temp);
      else  cti[i] =         temp;
   }
   
   return(0);
}

